Index: src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 4677)
+++ src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 4678)
@@ -2062,121 +2085,129 @@
 		return fileReader;
 	}
 
-    /* Delete relations */
-    private void deleteRelations() throws SAXException
-    {
-        PreparedStatement pStmt = null;
-        String sql = "DELETE FROM xml_relation where docid =?";
-        try {
-            pStmt = connection.prepareStatement(sql);
-            //bind variable
-            pStmt.setString(1, docid);
-            //execute query
-            pStmt.execute();
-            pStmt.close();
-        }//try
-        catch (SQLException e) {
-            throw new SAXException("EMLSAXHandler.deleteRelations(): "
-                    + e.getMessage());
-        }//catch
-        finally {
-            try {
-                pStmt.close();
-            }//try
-            catch (SQLException ee) {
-                throw new SAXException("EMLSAXHandler.deleteRelations: "
-                        + ee.getMessage());
-            }//catch
-        }//finally
-    }
+	/* Delete relations */
+	private void deleteRelations() throws SAXException {
+		PreparedStatement pStmt = null;
+		String sql = "DELETE FROM xml_relation where docid =?";
+		try {
+			pStmt = connection.prepareStatement(sql);
+			// bind variable
+			pStmt.setString(1, docid);
+			// execute query
+			pStmt.execute();
+			pStmt.close();
+		}// try
+		catch (SQLException e) {
+			throw new SAXException("EMLSAXHandler.deleteRelations(): " + e.getMessage());
+		}// catch
+		finally {
+			try {
+				pStmt.close();
+			}// try
+			catch (SQLException ee) {
+				throw new SAXException("EMLSAXHandler.deleteRelations: "
+						+ ee.getMessage());
+			}// catch
+		}// finally
+	}
 
-    /* Write an online data file id into xml_relation table. The dataId shouldnot
-     * have the revision
-     */
-    private void writeOnlineDataFileIdIntoRelationTable(String dataId)
-            throws SAXException
-    {
-        PreparedStatement pStmt = null;
-        String sql = "INSERT into xml_relation (docid, packagetype, subject, "
-                + "relationship, object) values (?, ?, ?, ?, ?)";
-        try {
-            pStmt = connection.prepareStatement(sql);
-            //bind variable
-            pStmt.setString(1, docid);
-            pStmt.setString(2, DocumentImpl.EML2_1_0NAMESPACE);
-            pStmt.setString(3, docid);
-            pStmt.setString(4, RELATION);
-            pStmt.setString(5, dataId);
-            //execute query
-            pStmt.execute();
-            pStmt.close();
-        }//try
-        catch (SQLException e) {
-            throw new SAXException(
-                    "EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): "
-                            + e.getMessage());
-        }//catch
-        finally {
-            try {
-                pStmt.close();
-            }//try
-            catch (SQLException ee) {
-                throw new SAXException(
-                        "EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): "
-                                + ee.getMessage());
-            }//catch
-        }//finally
+	/*
+	 * Write an online data file id into xml_relation table. The dataId
+	 * shouldnot have the revision
+	 */
+	private void writeOnlineDataFileIdIntoRelationTable(String dataId)
+			throws SAXException {
+		PreparedStatement pStmt = null;
+		String sql = "INSERT into xml_relation (docid, packagetype, subject, "
+				+ "relationship, object) values (?, ?, ?, ?, ?)";
+		try {
+			pStmt = connection.prepareStatement(sql);
+			// bind variable
+			pStmt.setString(1, docid);
+			pStmt.setString(2, DocumentImpl.EML2_1_0NAMESPACE);
+			pStmt.setString(3, docid);
+			pStmt.setString(4, RELATION);
+			pStmt.setString(5, dataId);
+			// execute query
+			pStmt.execute();
+			pStmt.close();
+		}// try
+		catch (SQLException e) {
+			throw new SAXException(
+					"EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): "
+							+ e.getMessage());
+		}// catch
+		finally {
+			try {
+				pStmt.close();
+			}// try
+			catch (SQLException ee) {
+				throw new SAXException(
+						"EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): "
+								+ ee.getMessage());
+			}// catch
+		}// finally
 
-    }//writeOnlineDataFileIdIntoRelationTable
+	}// writeOnlineDataFileIdIntoRelationTable
 
-    /*
-     * This method will handle data file in online url. If the data file is in
-     * ecogrid protocol, then the datafile identifier(without rev)should be put
-     * into onlineDataFileRelationVector. The  docid in this vector will be
-     * insert into xml_relation table in endDocument().
-     * If the data file doesn't exsit in xml_documents or
-     * xml_revision table, or the user has all permission to the data file if
-     * the docid already existed, the data file id (without rev)will be put into
-     * onlineDataFileTopAccessVector. The top access rules specified in this eml
-     * document will apply to the data file.
-     * NEED to do:
-     * We should also need to implement http and ftp. Those
-     * external files should be download and assign a data file id to it.
-     */
-    private void handleOnlineUrlDataFile(String url) throws SAXException
-    {
-      logMetacat.warn("The url is "+ url);
-      // if the url is not a ecogrid protocol, null will be getten
-      String accessionNumber =
-                 MetaCatUtil.getAccessionNumberFromEcogridIdentifier(url);
-      if (accessionNumber != null)
-      {
-        // handle ecogrid protocol
-        // get rid of revision number to get the docid.
-        String docid = MetaCatUtil.getDocIdFromAccessionNumber(accessionNumber);
-        onlineDataFileIdInRelationVector.add(docid);
-        try
-        {
+	/*
+	 * This method will handle data file in online url. If the data file is in
+	 * ecogrid protocol, then the datafile identifier(without rev)should be put
+	 * into onlineDataFileRelationVector. The docid in this vector will be
+	 * insert into xml_relation table in endDocument(). If the data file doesn't
+	 * exsit in xml_documents or xml_revision table, or the user has all
+	 * permission to the data file if the docid already existed, the data file
+	 * id (without rev)will be put into onlineDataFileTopAccessVector. The top
+	 * access rules specified in this eml document will apply to the data file.
+	 * NEED to do: We should also need to implement http and ftp. Those external
+	 * files should be download and assign a data file id to it.
+	 */
+	private void handleOnlineUrlDataFile(String url) throws SAXException {
+		logMetacat.warn("The url is " + url);
 
-          if (!AccessionNumber.accNumberUsed(docid))
-          {
-            onlineDataFileIdInTopAccessVector.add(docid);
-          }
-          PermissionController controller = new
-              PermissionController(accessionNumber);
-          if (controller.hasPermission(
-              user, groups, AccessControlInterface.ALLSTRING))
-          {
-            onlineDataFileIdInTopAccessVector.add(docid);
-          }
-        }//try
-        catch(Exception e)
-        {
-          logMetacat.error("Eorr in " +
-                                "Eml210SAXHanlder.handleOnlineUrlDataFile is " +
-                                 e.getMessage());
-          throw new SAXException(e.getMessage());
-        }
-      }
-    }
+		if (currentDistributionSection == null) {
+			throw new SAXException("Trying to set the online file name for a null"
+					+ " distribution section");
+		}
+
+		// if the url is not in ecogrid protocol, null will be returned
+		String accessionNumber = MetaCatUtil.getAccessionNumberFromEcogridIdentifier(url);
+		if (accessionNumber == null) {
+			// the accession number is null if the url does not references a
+			// local data file (url would start with "ecogrid://"
+			currentDistributionSection
+					.setDistributionType(DistributionSection.ONLINE_DATA_DISTRIBUTION);
+		} else {
+			// handle ecogrid protocol
+			// get rid of revision number to get the docid.
+			String docid = MetaCatUtil.getDocIdFromAccessionNumber(accessionNumber);
+
+			currentDistributionSection
+					.setDistributionType(DistributionSection.DATA_DISTRIBUTION);
+			currentDistributionSection.setDataFileName(docid);
+
+			// distributionOnlineFileName = docid;
+			onlineDataFileIdInRelationVector.add(docid);
+			try {
+
+				if (!AccessionNumber.accNumberUsed(docid)) {
+					onlineDataFileIdInTopAccessVector.add(docid);
+				}
+				PermissionController controller = new PermissionController(
+						accessionNumber);
+				if (controller.hasPermission(user, groups,
+						AccessControlInterface.ALLSTRING)) {
+					onlineDataFileIdInTopAccessVector.add(docid);
+				} else {
+		            throw new SAXException(UPDATEACCESSERROR);
+				}
+			}// try
+			catch (Exception e) {
+				logMetacat.error("Eorr in "
+								+ "Eml210SAXHanlder.handleOnlineUrlDataFile is "
+								+ e.getMessage());
+				throw new SAXException(e.getMessage());
+			}
+		}
+	}
 }
